// --------------------------------------------------------------------------------------------------------------------
// <copyright file="xDocs.cs" company="">
//   deanlunz@createdbyx.com
//   http://www.createdbyx.com
// </copyright>
// <summary>
//   Defines the xDocs type.
// </summary>
// --------------------------------------------------------------------------------------------------------------------
using System;
using System.Text;
using System.Collections.Generic;
using System.Xml;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Net;

public partial class xDocs : System.Web.UI.UserControl
{
    private string url;

    public string URL
    {
        get { return url; }
        set { url = value; }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        // get xml file
        //   string url = e.Body.Substring(startPos + 7, endPos - (startPos + 7)).Trim();
        while (!string.IsNullOrEmpty(url) && url.StartsWith("~"))
        {
            url = url.Remove(0, 1);
        }
        // try to download file
        XmlDocument doc = new XmlDocument();
        Uri path = new Uri(Page.Request.Url.ToString()); ;//= BlogEngine.Core.Page.GetPage(((BusinessBase<Page, Guid>)sender).Id).AbsoluteLink;
        string test = path.ToString();// path.GetComponents(UriComponents.SchemeAndServer, UriFormat.Unescaped);

        UriBuilder b = new UriBuilder(test);
        b.Path = url;
        b.Query = string.Empty;

        try
        {
            doc.Load(b.ToString());

        }
        catch (Exception)
        {
            this.litContent.Text = "Error: Could not load url " + b.ToString();
            return;
        }

        // process data and correct generics
        FixNodes(doc.DocumentElement.SelectNodes("members/member"));

        string TypeID = null;
        string MemberID = null;
        if (Page.IsPostBack)
        {
            if (!string.IsNullOrEmpty(Request.Form["__EVENTTARGET"]))
            {
                if (Request.Form["__EVENTTARGET"].Equals(this.litHandler.UniqueID))
                {
                    TypeID = Request.Form["__EVENTARGUMENT"];
                }
                else if (Request.Form["__EVENTTARGET"].Equals(this.litMemberHandler.UniqueID))
                {
                    MemberID = Request.Form["__EVENTARGUMENT"];
                }
                //if (!int.TryParse(Request.Form["__EVENTARGUMENT"], out UserID))
                //<Display error>
                //else
                //ToDelete(UserID);
                //}
                //else if (Request.Form["__EVENTTARGET"].Equals(ltrDeleteAll.UniqueID))
                //{
                //ToDelete(0);
                //}
            }
        }
        //ToBindData();

        StringBuilder content = new StringBuilder();
        if (doc.DocumentElement.Name == "doc")
        {
            if (string.IsNullOrEmpty(TypeID))
            {
                if (string.IsNullOrEmpty(MemberID))
                {
                    ListAllTypes(doc, content);
                }
                else
                {
                    ShowMemberInfo(doc, TypeID, MemberID, content);
                }
            }
            else
            {
                ListAllTypeMembers(doc, path, TypeID, content);
            }
        }

        this.litContent.Text = content.ToString();
    }

    private void FixNodes(XmlNodeList nodelist)
    {
        foreach (XmlNode node in nodelist)
        {

            XmlNode att = (node.Attributes == null ? null : node.Attributes.GetNamedItem("name"));
            if (att != null)
            {
                string prefix = att.InnerText.Substring(0, 2);
                string link = att.InnerText.Substring(2);
                if (link.IndexOf("`") != -1)
                {
                    int pos = link.IndexOf("`");
                    while (pos + 1 < link.Length && char.IsNumber(link[pos + 1]))
                    {
                        int len = 0;
                        int tmppos = pos + 1;
                        string num = link[pos + 1].ToString();
                        while (tmppos + 1 < link.Length && char.IsNumber(link[tmppos + 1]))
                        {
                            num += link[tmppos + 1];
                            tmppos++;
                        }
                        int.TryParse(num, out len);
                        link = link.Remove(pos, num.Length + 1);
                        string tmp = "&lt;" + new string(',', (len == 0 ? 0 : len - 1)) + "&gt;";
                        link = link.Insert(pos, tmp);

                        pos = link.IndexOf("`", pos + tmp.Length);
                    }
                }
                att.InnerText = prefix + link;
                att.InnerText = att.InnerText.Replace("#ctor", "Constructor");
                att.InnerText = att.InnerText.Replace("{&lt;", "&lt;");
                att.InnerText = att.InnerText.Replace("&gt;}", "&gt;");

                if (att.InnerText.Contains("@"))
                {
                    int pos = att.InnerText.IndexOf("@");
                    int tmppos = pos - 1;
                    while (att.InnerText[tmppos] != '(' && att.InnerText[tmppos] != ',')
                    {
                        tmppos--;
                    }
                    att.InnerText = att.InnerText.Remove(pos, 1);
                    att.InnerText = att.InnerText.Insert(tmppos + 1, "out ");
                }
                if (att.InnerText.Contains("("))
                {
                    int pos = att.InnerText.IndexOf("(") + 1;
                    while (pos < att.InnerText.Length && att.InnerText[pos] != ')')
                    {
                        if (att.InnerText[pos] == ',' && pos + 1 < att.InnerText.Length && att.InnerText[pos + 1] != ' ')
                        {
                            att.InnerText = att.InnerText.Insert(pos + 1, " ");
                            pos++;
                        }
                        pos++;
                    }
                }
            }

            // fix see tags
            // <see cref=""/>
            //XmlNode tmpNode = node.SelectSingleNode("summary");
            //if (tmpNode != null) tmpNode.InnerXml = ReplaceSeeTags(tmpNode.InnerXml);
            //foreach (XmlNode nx in node.SelectNodes("param"))
            //{
            //    nx.InnerXml = ReplaceSeeTags(nx.InnerXml);
            //}
        }
    }

    private string ReplaceSeeTags(string value)
    {
        if (string.IsNullOrEmpty(value) == false && value.Contains("<see cref=\""))
        {

            int sPos = value.IndexOf("<see cref=\"");
            while (sPos != -1)
            {
                int ePos = value.IndexOf("\"", sPos + 11);
                if (ePos != -1)
                {
                    string type = value.Substring(sPos + 13, ePos - (sPos + 13));
                    string name = type.Substring(type.LastIndexOf(".") + 1);
                    int tmpIndex = name.IndexOfAny(new char[] { '(', '<' });
                    if (tmpIndex != -1) name = name.Substring(0, tmpIndex);

                    type = type.Substring(0, type.LastIndexOf("."));

                    string link;
                    if (value.Substring(sPos + 11, 1) != "T")
                    {
                        link = "<a href=\"" + Page.ClientScript.GetPostBackClientHyperlink(this.litMemberHandler, type + "{***}" + name) + "\">" + name + "</a>";
                    }
                    else
                    {
                        link = "<a href=\"" + Page.ClientScript.GetPostBackClientHyperlink(this.litHandler, type + "." + name) + "\">" + name + "</a>";
                        // link = "<a href=\"" + Page.ClientScript.GetPostBackClientHyperlink(this.litMemberHandler, type + "{***}" + name) + "\">" + name + "</a>";
                    }

                    value = value.Remove(sPos, ePos - sPos);
                    value = value.Remove(sPos, (value.IndexOf(">", sPos) + 1) - sPos);

                    value = value.Insert(sPos, link);
                }

                sPos = value.IndexOf("<see cref=\"");
            }
        }

        return value;
    }

    private void ShowMemberInfo(XmlDocument doc, string TypeID, string MemberID, StringBuilder content)
    {

        string mem = MemberID.Substring(MemberID.IndexOf("{***}") + 5);
        // if (mem.Contains("&")) mem = mem.Substring(0, mem.IndexOf("&") - 1);

        string type = MemberID.Substring(0, MemberID.IndexOf("{***}")); ;// this.hfType.Value;// b.Query.Substring(b.Query.IndexOf("type=") + 5);
        // if (type.Contains("&")) type = type.Substring(0, type.IndexOf("&"));
        // type = type.Contains(".") ? type.Substring(type.LastIndexOf(".") + 1) : type;
        string link = type;
        string shortLink = link.Contains(".") ? link.Substring(link.LastIndexOf(".") + 1) : link;
        link = "<a href=\"" + Page.ClientScript.GetPostBackClientHyperlink(this.litHandler, link) + "\">" + shortLink + "</a>";
        content.AppendLine("<p><a href=\"" + Page.Request.Url.ToString() + "\" >All Types</a> > " + link + "</p>");

        List<XmlNode> items = GetMembers(doc.DocumentElement, "P", type);
        items.AddRange(GetMembers(doc.DocumentElement, "M", type).ToArray());
        items.AddRange(GetMembers(doc.DocumentElement, "E", type).ToArray());
        items.AddRange(GetMembers(doc.DocumentElement, "F", type).ToArray());

        if (items.Count > 0)
        {

            foreach (XmlNode nx in items)
            {
                string name = GetMemberName(nx, type);
                //name = name.Replace("&lt;", "<").Replace("&gt;", ">");

                if ((string.Compare(name, mem) == 0))
                {
                    //mem = mem.Contains("(") ? mem.Substring(0, mem.IndexOf("(")) : mem;
                    // mem = mem.Replace("<", "&lt;");
                    // mem = mem.Replace(">", "&gt;");

                    content.AppendLine("<p class=\"xdoccategory\">" + mem + "</p>");
                    content.AppendLine("<p>" + GetSummery(nx) + "</p>");

                    Dictionary<string, string> args = GetArguments(nx, "typeparam");
                    if (args.Count > 0)
                    {
                        content.AppendLine("<p class=\"xdoccategory\">Type Parameters</p>");
                        string[] tmplist = new string[args.Count];
                        args.Keys.CopyTo(tmplist, 0);
                        Array.Sort(tmplist);

                        foreach (string key in tmplist)
                        {
                            content.AppendLine("<div class=\"xdocmemberitem\">");
                            content.Append("<div class=\"xdocmembername\">" + key + "</div>");
                            content.Append("<div class=\"xdocmembervalue\">" + args[key] + "</div><br/>\r\n");
                            content.AppendLine("</div>");
                        }
                    }

                    args = GetArguments(nx, "param");
                    if (args.Count > 0)
                    {
                        content.AppendLine("<p class=\"xdoccategory\">Parameters</p>");
                        string[] tmplist = new string[args.Count];
                        args.Keys.CopyTo(tmplist, 0);
                        Array.Sort(tmplist);

                        foreach (string key in tmplist)
                        {
                            content.AppendLine("<div class=\"xdocmemberitem\">");
                            content.Append("<div class=\"xdocmembername\">" + key + "</div>");
                            content.Append("<div class=\"xdocmembervalue\">" + args[key] + "</div><br/>\r\n");
                            content.AppendLine("</div>");
                        }
                    }

                    string remarks = GetRemarks(nx);
                    if (string.IsNullOrEmpty(remarks) == false)
                    {
                        content.AppendLine("<p class=\"xdoccategory\">Remarks</p>");
                        content.AppendLine("<p>" + remarks + "</p>");
                    }

                    string example = GetExample(nx);
                    if (string.IsNullOrEmpty(example) == false)
                    {
                        content.AppendLine("<p class=\"xdoccategory\">Example</p>");
                        content.AppendLine("<p>" + example + "</p>");
                    }
                    break;
                }
            }
        }
    }

    private void ListAllTypeMembers(XmlDocument doc, Uri path, string TypeID, StringBuilder content)
    {
        string type = TypeID;// this.hfType.Value;// b.Query.Substring(b.Query.IndexOf("type=") + 5);
        // if (type.Contains("&")) type = type.Substring(0, type.IndexOf("&"));
        // type = type.Contains(".") ? type.Substring(type.LastIndexOf(".") + 1) : type;

        content.AppendLine("<p><a href=\"" + Page.Request.Url.ToString() + "\" >All Types</a></p>");

        int count = 0;
        XmlNodeList memItems = doc.DocumentElement.SelectNodes("members/member");
        XmlNode typeNode = null;

        foreach (XmlNode mem in memItems)
        {
            if (mem.Attributes.Count > 0)
            {
                XmlNode att = mem.Attributes.GetNamedItem("name");
                if (att != null)
                {
                    if (att.InnerText.StartsWith("T:"))
                    {
                        string tmp = att.InnerText.Substring(2);//.InnerText.Replace("`1", "<>");
                        tmp = tmp.Replace("&lt;", "<").Replace("&gt;", ">");
                        if (tmp.StartsWith(type) && tmp.Length == type.Length)
                        {
                            typeNode = mem;
                            break;
                            //if (tmp.Length > type.Length + 3)
                            //{
                            //    tmp = tmp.Substring(type.Length + 2, 1);
                            //    if (tmp == "<") { typeNode = mem; break; }
                            //}
                            //else if (tmp.Length == type.Length + 2)
                            //{
                            //    typeNode = mem;
                            //    break;
                            //}

                        }
                    }
                }
            }
        }

        if (typeNode != null)
        {

            type = typeNode.Attributes.GetNamedItem("name").InnerText;//.InnerText.Replace("`1", "<>");

            content.AppendLine("<p class=\"xdoccategory\">" + (type.Contains(".") ? type.Substring(type.LastIndexOf(".") + 1) : type) + "</p>");
            content.AppendLine("<p>" + GetSummery(typeNode) + "</p>");

            type = type.Replace("&lt;", "<").Replace("&gt;", ">");
            type = type.Substring(2);


            Dictionary<string, string> args = GetArguments(typeNode, "typeparam");
            if (args.Count > 0)
            {
                content.AppendLine("<p class=\"xdoccategory\">Type Parameters</p>");
                string[] tmplist = new string[args.Count];
                args.Keys.CopyTo(tmplist, 0);
                Array.Sort(tmplist);

                foreach (string key in tmplist)
                {
                    content.AppendLine("<div class=\"xdocmemberitem\">");
                    content.Append("<div class=\"xdocmembername\">" + key + "</div>");
                    content.Append("<div class=\"xdocmembervalue\">" + args[key] + "</div><br/>\r\n");
                    content.AppendLine("</div>");
                }
            }

            // find all properties
            List<XmlNode> tmpitems = GetMembers(doc.DocumentElement, "P", type);
            tmpitems.Sort(delegate(XmlNode left, XmlNode right)
                {
                    return string.Compare(left.Attributes.GetNamedItem("name").InnerText, right.Attributes.GetNamedItem("name").InnerText);
                });
            if (tmpitems.Count > 0) this.WriteMember(content, tmpitems, "Properties", type, path);

            tmpitems = GetMembers(doc.DocumentElement, "M", type);
            tmpitems.Sort(delegate(XmlNode left, XmlNode right)
                  {
                      return string.Compare(left.Attributes.GetNamedItem("name").InnerText, right.Attributes.GetNamedItem("name").InnerText);
                  });
            if (tmpitems.Count > 0) this.WriteMember(content, tmpitems, "Methods", type, path);

            tmpitems = GetMembers(doc.DocumentElement, "E", type);
            tmpitems.Sort(delegate(XmlNode left, XmlNode right)
                 {
                     return string.Compare(left.Attributes.GetNamedItem("name").InnerText, right.Attributes.GetNamedItem("name").InnerText);
                 });
            if (tmpitems.Count > 0) this.WriteMember(content, tmpitems, "Events", type, path);

            tmpitems = GetMembers(doc.DocumentElement, "F", type);
            tmpitems.Sort(delegate(XmlNode left, XmlNode right)
                 {
                     return string.Compare(left.Attributes.GetNamedItem("name").InnerText, right.Attributes.GetNamedItem("name").InnerText);
                 });
            if (tmpitems.Count > 0) this.WriteMember(content, tmpitems, "Fields", type, path);
        }
    }

    private void ListAllTypes(XmlDocument doc, StringBuilder content)
    {
        content.AppendLine("<p class=\"xdoccategory\">Types</p>");

        int count = 0;
        XmlNodeList memitems = doc.DocumentElement.SelectNodes("members/member");
        List<XmlNode> items = new List<XmlNode>();
        foreach (XmlNode mem in memitems)
        {
            items.Add(mem);
        }
        items.Sort(delegate(XmlNode left, XmlNode right)
        {
            return string.Compare(left.Attributes.GetNamedItem("name").InnerText, right.Attributes.GetNamedItem("name").InnerText);
        });


        foreach (XmlNode mem in items)
        {
            if (mem.Attributes.Count > 0)
            {
                XmlNode att = mem.Attributes.GetNamedItem("name");
                if (att != null)
                {
                    if (att.InnerText.StartsWith("T:"))
                    {
                        content.AppendLine("<div class=\"xdocmemberitem\">");
                        content.AppendLine("<div class=\"xdocmembername\">");

                        string link = att.InnerText.Substring(2);
                        string shortLink = link.Contains(".") ? link.Substring(link.LastIndexOf(".") + 1) : link;

                        //  this.hfType.Value = link;
                        // link = "<a href=\"" + path.PathAndQuery + (path.Query.StartsWith("?") ? "&" : "?") + "type=" + link + "\">" + shortLink + "</a>";
                        link = "<a href=\"" + Page.ClientScript.GetPostBackClientHyperlink(this.litHandler, link) + "\">" + shortLink + "</a>";
                        content.AppendLine(link.Trim());
                        // link = Page.ClientScript.GetPostBackClientHyperlink(this.litHandler, shortLink);
                        count++;
                        content.AppendLine("</div>");
                        content.AppendLine("<div class=\"xdocmembervalue\">");
                        content.AppendLine(GetSummery(mem));
                        content.AppendLine("</div>\r\n</div>" + (count < items.Count - 1 ? "<br/>" : string.Empty));
                    }
                }
            }
        }
        content.AppendLine("</p>");
    }

    //private static string FixGenericsForType(string att)
    //{
    //    string link = att.Substring(2);
    //    if (link.IndexOf("`") != -1)
    //    {
    //        int pos = link.IndexOf("`");
    //        if (pos + 1 < link.Length && char.IsNumber(link[pos + 1]))
    //        {
    //            int len = 1;
    //            int tmppos = pos + 1;
    //            while (tmppos + 1 < link.Length && char.IsNumber(link[tmppos + 1]))
    //            {
    //                len++;
    //                tmppos++;
    //            }
    //            link = link.Remove(pos, len + 1);
    //            link = link.Insert(pos, "&lt;" + new string(',', len) + "&gt;");
    //        }
    //    }
    //    return link;
    //}

    private void WriteMember(StringBuilder content, List<XmlNode> items, string category, string type, Uri path)
    {
        content.AppendLine("<p class=\"xdoccategory\">" + category + "</p>");
        content.AppendLine("<p>");
        int count = 0;
        foreach (XmlNode nx in items)
        {
            content.AppendLine("<div class=\"xdocmemberitem\">");
            string name = GetMemberName(nx, type);

            content.Append("<div class=\"xdocmembername\"><a href=\"");
            // content.Append(path.PathAndQuery + (path.Query.StartsWith("?") ? "&" : "?") + "member=" + name + "\">" + name + "</a></div>");
            content.Append(Page.ClientScript.GetPostBackClientHyperlink(this.litMemberHandler, type + "{***}" + name) + "\">" + name + "</a></div>");
            content.Append("<div class=\"xdocmembervalue\">" + GetSummery(nx) + "</div>");
            content.AppendLine("</div>");
            count++;
            if (count < items.Count) content.AppendLine("<br/>\r\n");
        }
        content.AppendLine("</p>");
    }

    private Dictionary<string, string> GetArguments(XmlNode nx, string name)
    {
        Dictionary<string, string> args = new Dictionary<string, string>();
        XmlNodeList items = nx.SelectNodes(name);
        foreach (XmlNode p in items)
        {
            args.Add(p.Attributes.GetNamedItem("name").InnerText, this.ReplaceSeeTags(p.InnerXml));
        }
        return args;
    }

    private string GetSummery(XmlNode nx)
    {
        XmlNode sum = nx.SelectSingleNode("summary");
        if (sum != null) return this.ReplaceSeeTags(sum.InnerText);
        return string.Empty;
    }

    private string GetRemarks(XmlNode nx)
    {
        XmlNode sum = nx.SelectSingleNode("remarks");
        if (sum != null) return this.ReplaceSeeTags(sum.InnerXml);
        return string.Empty;
    }

    private string GetExample(XmlNode nx)
    {
        XmlNode sum = nx.SelectSingleNode("example");
        if (sum != null)
        {
            string tmp = this.ReplaceSeeTags(sum.InnerXml);
            if (tmp.StartsWith("<![CDATA[") && tmp.EndsWith("]]>"))
            {
                tmp = tmp.Substring(9, tmp.Length - 12);
            }

            int csStart = tmp.IndexOf("<code>");
            int csEnd = tmp.LastIndexOf("</code>");
            if (csStart != -1 && csEnd != -1 && csEnd > csStart)
            {
                string code = tmp.Remove(csEnd, 7);
                code = code.Insert(csEnd, "</pre>");
                code = code.Remove(csStart, 6);
                code = code.Insert(csStart, "<pre>");
            }

            return tmp;
        }

        return string.Empty;
    }

    private string GetMemberName(XmlNode nx, string type)
    {
        XmlNode att = nx.Attributes.GetNamedItem("name");
        if (att != null)
        {
            string tmptype = att.InnerText;
            tmptype = tmptype.Replace("&lt;", "<").Replace("&gt;", ">");
            string tmp = tmptype.Substring(type.Length + 3);
            // tmp = tmp.Replace("``1(", "&lt;&gt;(");
            // tmp = tmp.Replace("#ctor", "Contructor");
            return tmp;
        }
        return string.Empty;
    }

    private List<XmlNode> GetMembers(XmlNode node, string ID, string type)
    {

        List<XmlNode> list = new List<XmlNode>();
        XmlNodeList items = node.SelectNodes("members/member");
        foreach (XmlNode mem in items)
        {
            if (mem.Attributes.Count > 0)
            {
                XmlNode att = (mem.Attributes == null ? null : mem.Attributes.GetNamedItem("name"));
                if (att != null && att.InnerText.StartsWith(ID))
                {
                    string tmptype = att.InnerText.Substring(2);
                    tmptype = tmptype.Replace("&lt;", "<").Replace("&gt;", ">");
                    // tmptype = att.InnerText.Substring(0, 2) + tmptype.Replace("#ctor", "Contructor");
                    if (tmptype.StartsWith(type) && tmptype.Length > type.Length && tmptype[type.Length] == '.')
                    {
                        list.Add(mem);
                        //if (tmptype.Length > type.Length + 3)
                        //{
                        //    string tmp = tmptype.Substring(type.Length + 2, 1);
                        //    if (tmp == "." || tmp == "<") list.Add(mem);
                        //}
                        //else
                        //{
                        //    list.Add(mem);
                        //}
                    }
                }
            }
        }
        return list;
    }
}
